unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Panel1: TPanel;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Slider: TTrackBar;
    cbShowCursor: TCheckBox;
    Timer1: TTimer;
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    { Private declarations }
    procedure WMGetMinMaxInfo(var Msg: TWMGetMinMaxInfo); message WM_GETMINMAXINFO;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormDestroy(Sender: TObject);
begin
  Timer1.Interval:= 0;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  {      }
  Panel1.Left:= (Form1.ClientWidth div 2) - Panel1.Width div 2;
  Panel1.Top:= (Form1.ClientHeight div 2) - Panel1.Height div 2;
  Image1.Picture:= nil;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  srect, drect, posForm: TRect;
  iWidth, iHeight, dmX, dmY: integer;
  itmpX, itmpY: real;
  c: TCanvas;
  hDesktop: HWND;
  cur: TPoint;
begin
  if not IsIconic(Application.Handle) then
  begin
    hDesktop:= GetDesktopWindow;
    GetCursorPos(cur);
    posForm:= Rect(Form1.Left, Form1.Top, Form1.Left + Form1.Width, Form1.Top + Form1.Height);
    if not PtInRect(posForm, cur) then
    begin
      if Panel1.Visible then Panel1.Visible:= false;
      if not Image1.Visible then Image1.Visible:= true;

      iWidth:= Image1.Width;
      iHeight:= Image1.Height;
      drect:= Rect(0, 0, iWidth, iHeight);

      itmpX:= iWidth / (Slider.Position * 4);
      itmpY:= iHeight / (Slider.Position * 4);

      srect:= Rect(cur.X, cur.Y, cur.X, cur.Y);
      InflateRect(srect, round(itmpX), round(itmpY));
      { ,     }
      if srect.Left < 0 then
        OffsetRect(srect, -srect.Left, 0);
      if srect.Top < 0 then
        OffsetRect(srect, 0, -srect.Top);
      if srect.Right > Screen.Width then
        OffsetRect(srect, -(srect.Right - Screen.Width), 0);
      if srect.Bottom > Screen.Height then
        OffsetRect(srect, 0, -(srect.Bottom - Screen.Height));

      c:= TCanvas.Create;
      try
        c.Handle:= GetDC(GetDesktopWindow);
        Image1.Canvas.CopyRect(drect, c, srect);
      finally
        ReleaseDC(hDesktop, c.Handle);
        c.Free;
      end;
      if cbShowCursor.Checked then
      begin
        with Image1.Canvas do
        begin
          dmX:= Slider.Position * 2 * (cur.X - srect.Left);
          dmY:= Slider.Position * 2 * (cur.Y - srect.Top);
          {   }
          MoveTo(dmX - (iWidth div 4), dmY);
          LineTo(dmX + (iWidth div 4), dmY);
          MoveTo(dmX, dmY - (iHeight div 4));
          LineTo(dmX, dmY + (iHeight div 4));
        end;
      end;
      Application.ProcessMessages;
      end
      else
      begin
        if not Panel1.Visible then
          Panel1.Visible:= true;
        if Image1.Visible then
          Image1.Visible:= false;
    end;
  end;
end;

procedure TForm1.WMGetMinMaxInfo(var Msg: TWMGetMinMaxInfo);
begin
  inherited;
  {    }
  Msg.MinMaxInfo^.ptMinTrackSize:= Point(158, 177);
  {    }
  Msg.MinMaxInfo^.ptMaxTrackSize:= Point(350, 350);
end;

end.
